com.io7m.r2.core.shaders.provided

## Class R2SurfaceShaderBasicReflectiveParameters.Builder

- java.lang.Object
- - com.io7m.r2.core.shaders.provided.R2SurfaceShaderBasicReflectiveParameters.Builder

- Enclosing class:
    R2SurfaceShaderBasicReflectiveParameters

      public static final class R2SurfaceShaderBasicReflectiveParameters.Builder
      extends Object

  Builds instances of type `R2SurfaceShaderBasicReflectiveParameters`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2SurfaceShaderBasicReflectiveParameters` | `build()` Builds a new `R2SurfaceShaderBasicReflectiveParameters`.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `from(R2SurfaceShaderBasicParametersValuesType instance)` Fill a builder with attribute values from the provided `com.io7m.r2.core.shaders.provided.R2SurfaceShaderBasicParametersValuesType` instance.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `from(R2SurfaceShaderBasicReflectiveParametersType instance)` Fill a builder with attribute values from the provided `com.io7m.r2.core.shaders.provided.R2SurfaceShaderBasicReflectiveParametersType` instance.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setAlbedoColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> albedoColor)` Initializes the value for the `albedoColor` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setAlbedoMix(float albedoMix)` Initializes the value for the `albedoMix` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setAlbedoTexture(R2Texture2DUsableType albedoTexture)` Initializes the value for the `albedoTexture` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setAlphaDiscardThreshold(float alphaDiscardThreshold)` Initializes the value for the `alphaDiscardThreshold` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setEmission(float emission)` Initializes the value for the `emission` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setEmissionTexture(R2Texture2DUsableType emissionTexture)` Initializes the value for the `emissionTexture` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setEnvironmentMix(float environmentMix)` Initializes the value for the `environmentMix` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setEnvironmentTexture(R2TextureCubeUsableType environmentTexture)` Initializes the value for the `environmentTexture` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setNormalTexture(R2Texture2DUsableType normalTexture)` Initializes the value for the `normalTexture` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setSpecularColor(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> specularColor)` Initializes the value for the `specularColor` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setSpecularExponent(float specularExponent)` Initializes the value for the `specularExponent` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setSpecularTexture(R2Texture2DUsableType specularTexture)` Initializes the value for the `specularTexture` attribute.
    `R2SurfaceShaderBasicReflectiveParameters.Builder` | `setTextureDefaults(R2TextureDefaultsType textureDefaults)` Initializes the value for the `textureDefaults` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final R2SurfaceShaderBasicReflectiveParameters.Builder from(R2SurfaceShaderBasicReflectiveParametersType instance)

      Fill a builder with attribute values from the provided `com.io7m.r2.core.shaders.provided.R2SurfaceShaderBasicReflectiveParametersType` instance.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### from

          public final R2SurfaceShaderBasicReflectiveParameters.Builder from(R2SurfaceShaderBasicParametersValuesType instance)

      Fill a builder with attribute values from the provided `com.io7m.r2.core.shaders.provided.R2SurfaceShaderBasicParametersValuesType` instance.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setTextureDefaults

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setTextureDefaults(R2TextureDefaultsType textureDefaults)

      Initializes the value for the `textureDefaults` attribute.
      Parameters:
        `textureDefaults` - The value for textureDefaults
      Returns:
        `this` builder for use in a chained invocation

    - #### setAlbedoColor

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setAlbedoColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> albedoColor)

      Initializes the value for the `albedoColor` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `albedoColor`.

      Parameters:
        `albedoColor` - The value for albedoColor
      Returns:
        `this` builder for use in a chained invocation

    - #### setSpecularColor

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setSpecularColor(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> specularColor)

      Initializes the value for the `specularColor` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `specularColor`.

      Parameters:
        `specularColor` - The value for specularColor
      Returns:
        `this` builder for use in a chained invocation

    - #### setEmission

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setEmission(float emission)

      Initializes the value for the `emission` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `emission`.

      Parameters:
        `emission` - The value for emission
      Returns:
        `this` builder for use in a chained invocation

    - #### setEmissionTexture

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setEmissionTexture(R2Texture2DUsableType emissionTexture)

      Initializes the value for the `emissionTexture` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `emissionTexture`.

      Parameters:
        `emissionTexture` - The value for emissionTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setAlbedoTexture

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setAlbedoTexture(R2Texture2DUsableType albedoTexture)

      Initializes the value for the `albedoTexture` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `albedoTexture`.

      Parameters:
        `albedoTexture` - The value for albedoTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setAlbedoMix

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setAlbedoMix(float albedoMix)

      Initializes the value for the `albedoMix` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `albedoMix`.

      Parameters:
        `albedoMix` - The value for albedoMix
      Returns:
        `this` builder for use in a chained invocation

    - #### setSpecularTexture

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setSpecularTexture(R2Texture2DUsableType specularTexture)

      Initializes the value for the `specularTexture` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `specularTexture`.

      Parameters:
        `specularTexture` - The value for specularTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setSpecularExponent

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setSpecularExponent(float specularExponent)

      Initializes the value for the `specularExponent` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `specularExponent`.

      Parameters:
        `specularExponent` - The value for specularExponent
      Returns:
        `this` builder for use in a chained invocation

    - #### setNormalTexture

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setNormalTexture(R2Texture2DUsableType normalTexture)

      Initializes the value for the `normalTexture` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `normalTexture`.

      Parameters:
        `normalTexture` - The value for normalTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setAlphaDiscardThreshold

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setAlphaDiscardThreshold(float alphaDiscardThreshold)

      Initializes the value for the `alphaDiscardThreshold` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `alphaDiscardThreshold`.

      Parameters:
        `alphaDiscardThreshold` - The value for alphaDiscardThreshold
      Returns:
        `this` builder for use in a chained invocation

    - #### setEnvironmentTexture

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setEnvironmentTexture(R2TextureCubeUsableType environmentTexture)

      Initializes the value for the `environmentTexture` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `environmentTexture`.

      Parameters:
        `environmentTexture` - The value for environmentTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setEnvironmentMix

          public final R2SurfaceShaderBasicReflectiveParameters.Builder setEnvironmentMix(float environmentMix)

      Initializes the value for the `environmentMix` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `environmentMix`.

      Parameters:
        `environmentMix` - The value for environmentMix
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public R2SurfaceShaderBasicReflectiveParameters build()

      Builds a new `R2SurfaceShaderBasicReflectiveParameters`.
      Returns:
        An immutable instance of R2SurfaceShaderBasicReflectiveParameters
      Throws:
        `IllegalStateException` - if any required attributes are missing

Copyright © 2016 <code@io7m.com> http://io7m.com